#!/bin/bash

set -e

start() {
  lapis migrate
  lapis serve
}

first_launch() {
  echo "Setting up for the first time"
  mkdir -p secrets
  local SECRET
  SECRET="$(openssl rand -hex 32)"
  echo "return { key = \"${SECRET}\",}" > secrets/secrets.lua
  touch "secrets/.touched.$LAPIS_ENVIRONMENT"
  mkdir -p data/db
  luajit schema.lua
  chmod -R a+rw data
  lapis migrate
  luajit create_default_accounts.lua
}

if [[ $# -ne 1 ]]; then
  export LAPIS_ENVIRONMENT="development"
  echo "WARN: no environment passed, assuming default (development)"
else
  export LAPIS_ENVIRONMENT="$1"
fi

echo "Starting in $LAPIS_ENVIRONMENT"

if ! [ -f "secrets/.touched.$LAPIS_ENVIRONMENT" ]; then
  first_launch
fi

start
